Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# EC2N Class Reference

`#include <ec2n.h>`

Inheritance diagram for EC2N:

List of all members.

## Detailed Description

Elliptic Curve over GF(2^n).

Definition at line 30 of file ec2n.h.

## Public Types
typedef GF2NP | Field
typedef Field::Element | FieldElement
typedef EC2NPoint | Point
typedef EC2NPoint | Element
## Public Member Functions
| EC2N ()
| EC2N (const Field &field, const Field::Element &a, const Field::Element &b)
| EC2N (BufferedTransformation &bt)
void | DEREncode (BufferedTransformation &bt) const
bool | Equal (const Point &P, const Point &Q) const
const Point & | Identity () const
const Point & | Inverse (const Point &P) const
bool | InversionIsFast () const
const Point & | Add (const Point &P, const Point &Q) const
const Point & | Double (const Point &P) const
Point | Multiply (const Integer &k, const Point &P) const
Point | CascadeMultiply (const Integer &k1, const Point &P, const Integer &k2, const Point &Q) const
bool | ValidateParameters (RandomNumberGenerator &rng, unsigned int level=3) const
bool | VerifyPoint (const Point &P) const
unsigned int | EncodedPointSize (bool compressed=false) const
bool | DecodePoint (Point &P, BufferedTransformation &bt, unsigned int len) const
bool | DecodePoint (Point &P, const byte *encodedPoint, unsigned int len) const
void | EncodePoint (byte *encodedPoint, const Point &P, bool compressed) const
void | EncodePoint (BufferedTransformation &bt, const Point &P, bool compressed) const
Point | BERDecodePoint (BufferedTransformation &bt) const
void | DEREncodePoint (BufferedTransformation &bt, const Point &P, bool compressed) const
Integer | FieldSize () const
const Field & | GetField () const
const FieldElement & | GetA () const
const FieldElement & | GetB () const
bool | operator== (const EC2N &rhs) const
virtual const Element & | Subtract (const Element &a, const Element &b) const
virtual Element & | Accumulate (Element &a, const Element &b) const
virtual Element & | Reduce (Element &a, const Element &b) const
virtual Element | ScalarMultiply (const Element &a, const Integer &e) const
virtual Element | CascadeScalarMultiply (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
virtual void | SimultaneousMultiply (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const

The documentation for this class was generated from the following files:

- ec2n.h
- ec2n.cpp